(*****************************************************************************
          You should deactivate the Debugger option "Stop at Exceptions"
          in the Delphi environment. Else the application is INTERRUPTED by
          empty strings, + or -, ... in the Edit2.
 *****************************************************************************)
unit Demo1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Fctpars, StdCtrls, ExtCtrls, Buttons, Menus;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    BitBtn1: TBitBtn;
    RadioGroup1: TRadioGroup;
    Button2: TButton;
    FunctionParser1: TFunctionParser;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
    with FunctionParser1 do begin
       try
           VarValues[1]:=strtofloat(edit2.text);  //index 1 for x
       except
         on EConvertError do begin
             label3.caption:='No valid variable';
             exit;
         end;
       end;
       Term:=edit1.text;
       DoAll;
       if Valid
           then label3.caption:='Result = '+floattostr(Result)
           else label3.caption:=ErrorMessage;
    end;
end;

function twice(x:extended):extended;
begin
 result:=2*x;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   FunctionParser1.userfct:=twice;     //the userfunction is set to the
                                       // function above
   FunctionParser1.Functions.add('TWICE(X)=USERFCT(X)');  // the name of the
                                       // userfunction can be overwritten
   if not FunctionParser1.Prepare
      then showmessage(FunctionParser1.ErrorMessage);
   FunctionParser1.Constants.loadfromfile('Natconst.dat'); // includes physical
                                                           // constants
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  label3.caption:='';
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  functionparser1.anglemode:=TAnglemode(radiogroup1.itemindex);
  bitbtn1click(sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  application.terminate;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  FunctionParser1.showinfo;
end;

end.
